/* $RCSfile: hash.h,v $$Revision: 1.1.1.1 $$Date: 1996/08/19 10:13:36 $
 *
 *    Copyright (c) 1991, Larry Wall
 *
 *    You may distribute under the terms of either the GNU General Public
 *    License or the Artistic License, as specified in the README file.
 *
 * $Log: hash.h,v $
 * Revision 1.1.1.1  1996/08/19 10:13:36  downsj
 * Import of Perl 5.003 into the tree.  Makefile.bsd-wrapper and
 * config.sh.OpenBSD are the only local changes.
 *
 */

#define FILLPCT 60		/* don't make greater than 99 */

#ifdef DOINIT
char coeff[] = {
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1,
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1,
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1,
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1,
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1,
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1,
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1,
		61,59,53,47,43,41,37,31,29,23,17,13,11,7,3,1};
#else
extern char coeff[];
#endif

typedef struct hentry HENT;

struct hentry {
    HENT	*hent_next;
    char	*hent_key;
    STR		*hent_val;
    int		hent_hash;
};

struct htbl {
    HENT	**tbl_array;
    int		tbl_max;
    int		tbl_fill;
    int		tbl_riter;	/* current root of iterator */
    HENT	*tbl_eiter;	/* current entry of iterator */
};

bool hdelete _((HASH *tb, char *key));
STR * hfetch _(( HASH *tb, char *key ));
int hiterinit _(( HASH *tb ));
char * hiterkey _(( HENT *entry ));
HENT * hiternext _(( HASH *tb ));
STR * hiterval _(( HENT *entry ));
HASH * hnew _(( void ));
void hsplit _(( HASH *tb ));
bool hstore _(( HASH *tb, char *key, STR *val ));
