# Generated automatically from Makefile.in by configure.
# Makefile for menu source code.
#
# This makes the following:
#	libraries (normal/debug/profile/shared)
#
# The variable 'srcdir' refers to the source-distribution, and can be set with
# the configure script by "--srcdir=DIR".
#
# The rules are organized to produce the libraries for the configured models,

# turn off _all_ suffix rules; we'll generate our own
.SUFFIXES:

SHELL		= /bin/sh
THIS		= Makefile

MODEL		= normal
srcdir		= .
prefix		= /usr/local
exec_prefix	= /usr/local
libdir		= $(exec_prefix)/lib
includedir	= $(exec_prefix)/include

INSTALL		= /usr/bin/install -c
INSTALL_DATA	= ${INSTALL} -m 644

AWK		= awk
LN_S		= ln -s

CC		= gcc
CFLAGS		= -O

CPPFLAGS	=  -DNDEBUG -I. -I../include -I$(includedir) \
		  -DHAVE_CONFIG_H 

CCFLAGS		= $(CPPFLAGS) $(CFLAGS)

CFLAGS_NORMAL	= $(CCFLAGS)
CFLAGS_DEBUG	= $(CCFLAGS) -g -DTRACE
CFLAGS_PROFILE	= $(CCFLAGS) -pg
# Juergen Pfeifer reports:
# "Unfortunately -O crashes my linker on Linux and -O2 works"
# If your linker coughs and dies, try uncommenting the -O2
CFLAGS_SHARED	= $(CCFLAGS) unknown # -O2

CFLAGS_DEFAULT	= $(CFLAGS_NORMAL)

LINK		= $(CC)
LDFLAGS		=   

MK_SHARED_LIB	= echo unknown
REL_VERSION	= 1.9.9e
ABI_VERSION	= 3.0

RANLIB		= ranlib

LIBRARIES	=  ../lib/libmenu.a ../lib/libmenu_g.a

################################################################################
all ::	../include/menu.h ../include/eti.h ../include/mf_common.h $(LIBRARIES)

install :: install.libs

install.libs:: $(includedir) $(libdir)
	$(INSTALL_DATA) $(srcdir)/menu.h $(includedir)/menu.h
	$(INSTALL_DATA) $(srcdir)/eti.h $(includedir)/eti.h

$(includedir) \
$(libdir) :
	$(srcdir)/../mkinstalldirs $@

# make copies to simplify include-paths while still keeping menu's include
# file in this directory.
../include/menu.h : $(srcdir)/menu.h
	-rm -f $@
	cp $(srcdir)/menu.h $@
../include/eti.h : $(srcdir)/eti.h
	-rm -f $@
	cp $(srcdir)/eti.h $@
../include/mf_common.h : $(srcdir)/mf_common.h
	-rm -f $@
	cp $(srcdir)/mf_common.h $@
tags:
	ctags *.[ch]

TAGS:
	etags *.[ch]

clean ::
	-rm -f tags TAGS *~ ../include/menu.h ../include/eti.h \
	       ../include/mf_common.h

distclean: clean
	-rm -f Makefile

mostlyclean: clean

realclean: distclean

###############################################################################
# The remainder of this file is automatically generated during configuration
###############################################################################

NORMAL_OBJS = \
	../objects/m_attribs.o \
	../objects/m_cursor.o \
	../objects/m_driver.o \
	../objects/m_format.o \
	../objects/m_global.o \
	../objects/m_hook.o \
	../objects/m_item_cur.o \
	../objects/m_item_nam.o \
	../objects/m_item_new.o \
	../objects/m_item_opt.o \
	../objects/m_item_use.o \
	../objects/m_item_val.o \
	../objects/m_item_vis.o \
	../objects/m_items.o \
	../objects/m_new.o \
	../objects/m_opts.o \
	../objects/m_post.o \
	../objects/m_userptr.o \
	../objects/m_win.o

../lib/libmenu.a : $(NORMAL_OBJS)
	ar rv $@ $?
	$(RANLIB) $@

install.libs \
install.menu :: $(libdir) ../lib/libmenu.a
	@echo installing ../lib/libmenu.a as $(libdir)/libmenu.a 
	$(INSTALL_DATA) ../lib/libmenu.a $(libdir)/libmenu.a 
	$(RANLIB) $(libdir)/libmenu.a

clean ::
	rm -f ../lib/libmenu.a
	rm -f $(NORMAL_OBJS)

# Library objects

../objects/m_attribs.o :	$(srcdir)/m_attribs.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_attribs.c

../objects/m_cursor.o :	$(srcdir)/m_cursor.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_cursor.c

../objects/m_driver.o :	$(srcdir)/m_driver.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_driver.c

../objects/m_format.o :	$(srcdir)/m_format.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_format.c

../objects/m_global.o :	$(srcdir)/m_global.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_global.c

../objects/m_hook.o :	$(srcdir)/m_hook.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_hook.c

../objects/m_item_cur.o :	$(srcdir)/m_item_cur.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_item_cur.c

../objects/m_item_nam.o :	$(srcdir)/m_item_nam.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_item_nam.c

../objects/m_item_new.o :	$(srcdir)/m_item_new.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_item_new.c

../objects/m_item_opt.o :	$(srcdir)/m_item_opt.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_item_opt.c

../objects/m_item_use.o :	$(srcdir)/m_item_use.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_item_use.c

../objects/m_item_val.o :	$(srcdir)/m_item_val.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_item_val.c

../objects/m_item_vis.o :	$(srcdir)/m_item_vis.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_item_vis.c

../objects/m_items.o :	$(srcdir)/m_items.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_items.c

../objects/m_new.o :	$(srcdir)/m_new.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_new.c

../objects/m_opts.o :	$(srcdir)/m_opts.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_opts.c

../objects/m_post.o :	$(srcdir)/m_post.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_post.c

../objects/m_userptr.o :	$(srcdir)/m_userptr.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_userptr.c

../objects/m_win.o :	$(srcdir)/m_win.c \
			../include/menu.h
	cd ../objects; $(CC) $(CFLAGS_NORMAL) -c ../menu/m_win.c


DEBUG_OBJS = \
	../obj_g/m_attribs.o \
	../obj_g/m_cursor.o \
	../obj_g/m_driver.o \
	../obj_g/m_format.o \
	../obj_g/m_global.o \
	../obj_g/m_hook.o \
	../obj_g/m_item_cur.o \
	../obj_g/m_item_nam.o \
	../obj_g/m_item_new.o \
	../obj_g/m_item_opt.o \
	../obj_g/m_item_use.o \
	../obj_g/m_item_val.o \
	../obj_g/m_item_vis.o \
	../obj_g/m_items.o \
	../obj_g/m_new.o \
	../obj_g/m_opts.o \
	../obj_g/m_post.o \
	../obj_g/m_userptr.o \
	../obj_g/m_win.o

../lib/libmenu_g.a : $(DEBUG_OBJS)
	ar rv $@ $?
	$(RANLIB) $@

install.libs \
install.menu :: $(libdir) ../lib/libmenu_g.a
	@echo installing ../lib/libmenu_g.a as $(libdir)/libmenu_g.a 
	$(INSTALL_DATA) ../lib/libmenu_g.a $(libdir)/libmenu_g.a 
	$(RANLIB) $(libdir)/libmenu_g.a

clean ::
	rm -f ../lib/libmenu_g.a
	rm -f $(DEBUG_OBJS)

# Library objects

../obj_g/m_attribs.o :	$(srcdir)/m_attribs.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_attribs.c

../obj_g/m_cursor.o :	$(srcdir)/m_cursor.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_cursor.c

../obj_g/m_driver.o :	$(srcdir)/m_driver.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_driver.c

../obj_g/m_format.o :	$(srcdir)/m_format.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_format.c

../obj_g/m_global.o :	$(srcdir)/m_global.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_global.c

../obj_g/m_hook.o :	$(srcdir)/m_hook.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_hook.c

../obj_g/m_item_cur.o :	$(srcdir)/m_item_cur.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_item_cur.c

../obj_g/m_item_nam.o :	$(srcdir)/m_item_nam.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_item_nam.c

../obj_g/m_item_new.o :	$(srcdir)/m_item_new.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_item_new.c

../obj_g/m_item_opt.o :	$(srcdir)/m_item_opt.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_item_opt.c

../obj_g/m_item_use.o :	$(srcdir)/m_item_use.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_item_use.c

../obj_g/m_item_val.o :	$(srcdir)/m_item_val.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_item_val.c

../obj_g/m_item_vis.o :	$(srcdir)/m_item_vis.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_item_vis.c

../obj_g/m_items.o :	$(srcdir)/m_items.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_items.c

../obj_g/m_new.o :	$(srcdir)/m_new.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_new.c

../obj_g/m_opts.o :	$(srcdir)/m_opts.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_opts.c

../obj_g/m_post.o :	$(srcdir)/m_post.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_post.c

../obj_g/m_userptr.o :	$(srcdir)/m_userptr.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_userptr.c

../obj_g/m_win.o :	$(srcdir)/m_win.c \
			../include/menu.h
	cd ../obj_g; $(CC) $(CFLAGS_DEBUG) -c ../menu/m_win.c

